#include "smh_internal.h"
#include <string.h>

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
/* Basic lnbar function. Probably could use a test for a zero
   argument. */

TSIL_REAL LnBar (TSIL_REAL x)
{
  return TSIL_LOG (TSIL_FABS(x)/Q2);
}

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
/* Returns TRUE (1) is the numbers are equal and FALSE (0) if they are
   not equal.  */

int SMH_FPCompare (TSIL_REAL x, TSIL_REAL y)
{
  TSIL_REAL tmp;
  TSIL_REAL absx, absy;

  absx = TSIL_FABS(x); absy = TSIL_FABS(y);

  /* First check for 0 = 0? */
  if (absx < 1000*TSIL_TOL) {
    if (absy < 1000*TSIL_TOL) return TRUE;
    else return FALSE;
  }

  /* Make x the one with the larger abs value: */
  if (absx < absy) {
    tmp = y; y = x; x = tmp;
  }
  if (TSIL_FABS(x-y) < absx*TSIL_TOL) return TRUE;
  else return FALSE;
}

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
/* Gives the signed square root of a possibly negative real number    */

TSIL_REAL SMH_SGNSQRT (TSIL_REAL x)
{
  if (x < 0.0L) 
    return (-TSIL_SQRT(-x));
  else 
    return (TSIL_SQRT(x));
}

/* -------------------------------------------------------------- */
int SMH_Delta (int i, int j)
{
  if (i == j) return 1;
  else return 0;
}

/* ------------------------------------------------------------------ */

TSIL_REAL SMH_AbsSq (TSIL_COMPLEX x)
{
  return TSIL_FABS(x * x);
}
